IF OBJECT_ID ( 'CSC_SERVER', 'U' ) IS NOT NULL 
   DROP TABLE CSC_SERVER;
go
CREATE TABLE [dbo].[CSC_SERVER](
	[HIS_START_DATETIME] [varchar](60) NULL,
	[LAST_ASSIGN] [varchar](20) NULL,
	[THREAD_REPORT] [int] NULL,
	[SERVER_STATUS] [varchar](2) NULL,
	[REMARK] [varchar](1000) NULL,
	[THREAD_WORKFLOW] [int] NULL,
	[LOAD_STATIC_CONFIG] [varchar](250) NULL,
	[COMPANYID] [varchar](5) NOT NULL,
	[START_DATETIME] [varchar](20) NULL,
	[THREAD_PROCESS] [int] NULL,
	[SERVER_PRODUCTION] [varchar](2) NULL,
	[SERVER_NAME] [varchar](30) NOT NULL,
	[LAST_ACTION] [varchar](20) NULL,
	[ACTORID] [varchar](15) NULL,
	[CREATE_TIME] [varchar](8) NULL,
	[VERIFIED] [varchar](1) NULL,
	[WF_STATUS] [varchar](1) NULL,
	[EDIT_BY] [varchar](15) NULL,
	[WF_REF_DOC] [varchar](20) NULL,
	[CREATE_BY] [varchar](15) NULL,
	[EDIT_DATE] [varchar](10) NULL,
	[RUNNO] [varchar](30) NULL,
	[APPROVE] [varchar](15) NULL,
	[EDIT_TIME] [varchar](8) NULL,
	[CREATE_DATE] [varchar](10) NULL,
PRIMARY KEY CLUSTERED 
(
	[SERVER_NAME] ASC,
	[COMPANYID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
