IF OBJECT_ID ( 'LastAction', 'TR' ) IS NOT NULL 
   DROP trigger LastAction;
go
CREATE TRIGGER LastAction on CSC_SERVER FOR UPDATE AS 
BEGIN
	UPDATE CSC_SERVER SET LAST_ACTION = CONVERT(VARCHAR , GETDATE() , 120) 
  FROM Inserted Ins 
  WHERE CSC_SERVER.SERVER_NAME = Ins.SERVER_NAME AND Ins.LAST_ACTION = 'NOW'
END
go