IF OBJECT_ID ( 'broker_quque', 'TR' ) IS NOT NULL 
   DROP trigger broker_quque;
go
create trigger broker_quque on csc_quque
instead of INSERT as 
BEGIN
	DECLARE @SV_NAME varchar(20) , @group varchar(2),@type varchar(2) , @qid varchar(20) , @stat varchar(2);
	DECLARE @process int;
	SELECT @SV_NAME = inserted.server_name , @type = inserted.process_type , @group = inserted.process_group , @stat = inserted.process_status FROM inserted;
	
	IF( @stat = 'T' or @stat = 'W' )
	BEGIN
    IF( @SV_NAME != '' and @type = 'W' )
    BEGIN 
     SELECT @SV_NAME = SERVER_NAME FROM VW_CSC_SERVER WHERE SERVER_NAME = @SV_NAME AND THREAD_WORKFLOW > PROCESS_WORKFLOW
    END 
    
		IF( @SV_NAME = '' or @SV_NAME = 'NONE')
		BEGIN
			SET @SV_NAME = dbo.getReadyServer(@group , @type);
			PRINT 'getReadyServer ['+@group+' , '+@type+'] server_name = '+@SV_NAME
		END

		IF( @SV_NAME = '' and @type != 'R')
			BEGIN
				set @stat = 'B';
				PRINT 'Status B'
			END
		ELSE
			BEGIN
				SET @stat = 'T';
				PRINT 'Status T servername'+@SV_NAME
				UPDATE CSC_SERVER SET LAST_ASSIGN = CONVERT(VARCHAR , GETDATE() , 120) WHERE SERVER_NAME = @SV_NAME;
			END
	END
	INSERT INTO csc_quque(QUQUEID,PARENTID,TNAME,ENAME,PROCESS_STATUS,PROCESS_TYPE,PROCESS_GROUP,OWNER,CONDITION,REMOTE_IP,CLASS_NAME,SERVER_NAME,SCREEN_NAME,COMPANYID,START_TIME,END_TIME,PROCESS_MSG,EMPLOYEEID,USER_NAME,CANCLE_BY,CANCLE_TIME,CANCLE_MSG,REMARK,INTERVAL,INTERVAL_TYPE,NEXT_TIME,PROCESS_PRIORITY,RESULT_TYPE,PTYPE,CSC_LOG,EXPNAME,EXPFOLDER,PROVIDER_URL,HTTP_PORT,REFERKEY,TAG_INITMYPROCESS,EDIT_BY,EDIT_DATE,EDIT_TIME,CREATE_BY,CREATE_TIME,CREATE_DATE,ACTORID,APPROVE,VERIFIED,WF_STATUS,RUNNO,WF_REF_DOC) 
	SELECT QUQUEID,PARENTID,TNAME,ENAME,@stat,PROCESS_TYPE,PROCESS_GROUP,OWNER,CONDITION,REMOTE_IP,CLASS_NAME,@SV_NAME,SCREEN_NAME,COMPANYID,START_TIME,END_TIME,PROCESS_MSG,EMPLOYEEID,USER_NAME,CANCLE_BY,CANCLE_TIME,CANCLE_MSG,REMARK,INTERVAL,INTERVAL_TYPE,NEXT_TIME,PROCESS_PRIORITY,RESULT_TYPE,PTYPE,CSC_LOG,EXPNAME,EXPFOLDER,PROVIDER_URL,HTTP_PORT,REFERKEY,TAG_INITMYPROCESS,EDIT_BY,EDIT_DATE,EDIT_TIME,CREATE_BY,CREATE_TIME,CREATE_DATE,ACTORID,APPROVE,VERIFIED,WF_STATUS,RUNNO,WF_REF_DOC from inserted
end